﻿// See https://aka.ms/new-console-template for more information
class Employee
{
    private string Name;
    private DateTime Start;
    private DateTime End;

    public String ToString()
    {
        return Name + ";" + Start + ";" + End;
    }

    public static Employee ReadEmployee(TextReader input)
    {
        Employee emp = new Employee();
        Console.WriteLine("Name:");
        
        emp.Name = input.ReadLine();
        Console.WriteLine("Shift start time:");
        emp.Start = DateTime.Parse(input.ReadLine());
        Console.WriteLine("Time of the end of the shift:");
        emp.End = DateTime.Parse(input.ReadLine()); 

        return emp;
    }
    public static Employee Parse(String line)
    {
        Employee emp = new Employee();

        String[] parts = line.Split(";",3);
        emp.Name = parts[0];
        emp.Start = DateTime.Parse(parts[1]);
        emp.End = DateTime.Parse(parts[2]);

        return emp;
    }

    /**
     * @param args - command line parameters
     */
    public static void Main(String[] args)
    {
        List<Employee> employees = new();
        if(args.Length != 0  && args[0]!=null) {
            using (StreamReader reader = new StreamReader(args[0])) { 
                if (reader == null)
                {
                    Console.WriteLine("File {0} does not exist.", args[0]);
                    return;
                }
            String line;
            while((line = reader.ReadLine())!=null)
            {
                Employee emp = Employee.Parse(line);
                employees.Add(emp);
            }

                ListEmployees(employees);
                employees.Add(ReadEmployee(Console.In));
                ListEmployees(employees);
            }
        }
}

    private static void AddEmployee(List<Employee> employees)
    {
        throw new NotImplementedException();
    }

    private static void ListEmployees(List<Employee> employees)
    {
        foreach (Employee emp in employees)
        {
            Console.WriteLine($"Employees: {emp.Name}\nStart:{emp.Start}\nEnd:{emp.End}\n\n");
        }
    }
}
